<template>
  <div class="custom-manage">
    <div class="tab-view">
      <el-tabs v-model="activeName" @tab-click="tabsClick">
        <el-tab-pane label="公海客户" name="first"></el-tab-pane>
        <el-tab-pane label="我的客户" name="second"></el-tab-pane>
      </el-tabs>
      <!-- <div class="sel-gonghai">
        <el-select v-model="gonghaiValue" placeholder="请选择" class="query-class-sel" size="mini" disabled>
          <el-option v-for="item in gonghaiOptions" :key="item.value" :label="item.label" :value="item.value">
          </el-option>
        </el-select>
        <div class="query-class-btn">
          <i class="el-icon-setting"></i>
        </div>
      </div> -->
    </div>

    <div class="filter">
      <div class="filter-card">
        <CommonSearch
            :show-add="false"
            :show-download="false"
            :amount-view="false"
            :show-action-btn="false"
            placeholder="请输入客户名称"
            @searchClick="onFilterSearch"
        >
          <template slot="leftButton">
            <el-button size="small" type="primary"  @click="addBtnClick">新建</el-button>
            <el-button size="small"  @click="delClick">删除</el-button>
          </template>
        </CommonSearch>
      </div>
    </div>

    <div class="body">
      <div class="body-card">
        <div class="list-view">
          <TableCommonView
              ref="tableListRef"
              v-loading="loading"
              :table-list="tableList"
              @selClientClick="selClientClick"
              @selContactsClick="selContactsClick"
              @getSelectArray="getSelectArray"
              @selTableCol="selTableCol"
          >
            <template slot="tableButton">
              <el-table-column label="操作" width="150">
                <template slot-scope="scope">
                  <el-button v-if="activeName === 'first'" type="text" size="small" @click="allocationBtnClick(scope.row)"
                  >分配</el-button
                  >
                  <el-button v-else type="text" size="small" @click="changeHighSeasClick(scope.row)">变更公海</el-button>
                  <el-button @click="handleClick(scope.row)" type="text" size="small">编辑</el-button>
                  <el-button @click="followupClick(scope.row)" type="text" size="small">跟进</el-button>
                  <!-- <el-button @click="delClick(scope.row.id)" type="text" size="small">删除</el-button> -->
                </template>
              </el-table-column>
            </template>
          </TableCommonView>
        </div>
        <div class="btn-pager">
          <PagerView class="page" :pager-options="pagerOptions" v-on="pagerEvents" />
        </div>
      </div>
    </div>

    <!-- 新建/编辑客户管理 -->
    <AddClientManageDialog v-if="editConfig.visible" :edit-client-manage-config="editConfig" />
    <!-- 客户详情 -->
    <DetailClientManage v-if="clientDeail.visible" :client-manage-detail="clientDeail" />
    <!-- 联系人详情 -->
    <DetailContacts v-if="contactsDeail.visible" :contacts-detail="contactsDeail" />
    <!-- 新建/编辑跟进记录 -->
    <AddFollowupRecordsDialog v-if="editFollowupConfig.visible" :edit-contacts-config="editFollowupConfig" />
    <!-- 分配 -->
    <AllocationDialog v-if="allocationConfig.visible" :edit-common-config="allocationConfig" />
  </div>
</template>

<script>
import AddClientManageDialog from "@/views/client/client/AddClientManageDialog"
import { getClientList, getDeleteClient } from "@/api/client/client"
import pageMixin from "@/components/makepager/pager/mixin/pageMixin"
import AddFollowupRecordsDialog from "@/views/client/followupRecords/AddFollowupRecordsDialog"
import AllocationDialog from "@/views/client/client/AllocationDialog"
import { getAssign } from "@/api/common/other"

export default {
  name: "CustomManage",
  props: {},
  mixins: [pageMixin],
  components: {
    AddClientManageDialog,
    DetailContacts: () => import("@/views/client/contacts/DetailContacts"),
    DetailClientManage: () => import("@/views/client/client/DetailClientManage"),
    AddFollowupRecordsDialog,
    AllocationDialog
  },
  computed: {},
  data() {
    return {
      tableList: {},
      loading: false,
      activeName: "first",
      gonghaiValue: "",
      gonghaiOptions: [],
      queryClassOptions: [
        { value: "1", label: "全部" },
        { value: "2", label: "潜在客户" },
        { value: "3", label: "成交客户" },
        { value: "4", label: "今日待联系" },
        { value: "5", label: "本月需回访" },
        { value: "6", label: "超过15天未联系" }
      ],
      searchOptions: [],
      operatesList: [
        { id: "1", name: "共享" },
        { id: "2", name: "群发邮件" },
        { id: "3", name: "群发短信" },
        { id: "4", name: "批量编辑" },
        { id: "5", name: "变更公海" },
        { id: "6", name: "提交审批" },
        { id: "7", name: "导出" },
        { id: "8", name: "下载全部附件" }
      ],
      editConfig: {
        visible: false,
        title: "新建",
        infomation: {}
      },
      contactsDeail: {
        visible: false,
        infomation: {}
      },
      clientDeail: {
        visible: false,
        infomation: {}
      },
      search_map: {},
      selValueList: [],
      editFollowupConfig: {
        visible: false,
        title: "新建",
        infomation: {}
      },
      allocationConfig: {
        visible: false,
        infomation: {}
      },
      not_admin: 2,
      tableColumn:[
        { label: "客户名称", prop: "name", min: 100, isClientClick: true, default:true}, // 客户名称
        { label: "销售负责人", prop: "member_name" }, // 销售负责人
        { label: "重要级别", prop: "client_level" }, // 重要级别
        { label: "下次回访日期", prop: "next_visit_time", min: 90 }, // 下次回访日期
        { label: "详细地址", prop: "detail_address", min: 200 }, // 详细地址
        { label: "客户状态", prop: "client_status" }, // 客户状态
        { label: "联系人姓名", prop: "contact_name", isContactClick: true }, // 联系人姓名
        { label: "联系人手机号码", prop: "contact_phone" } // 手机号码
      ],
      showCol:['客户名称','销售负责人','重要级别','下次回访日期','详细地址','客户状态','联系人姓名','联系人手机号码']
    }
  },
  created() {
    this.setTable()
    this.search_map = {
      not_admin: this.not_admin
    }
    this.getData()
  },
  methods: {
    setTable() {
      this.tableList = {
        tableInfomation: [],
        allcol: [],
        showcol: this.showCol,
        tableColumn:this.setColumnVisible(this.showCol)
      }
      this.tableList.allcol = this.tableList.tableColumn.filter(ele=>!ele.default).map(ele=>ele.label);
      this.searchOptions = []
      for (let i = 0; i < this.tableList.tableColumn.length; i++) {
        const label = this.tableList.tableColumn[i].label
        const value = this.tableList.tableColumn[i].prop
        this.searchOptions.push({ value: value, label: label })
      }
    },
    setColumnVisible(showCol){
      return  this.tableColumn.map(ele=>{
        return {
          ...ele,
          isShowColumn:showCol.includes(ele.label)
        }
      })
    },
    selTableCol(val) {
      this.showcol = val;
      this.tableList.tableColumn = this.setColumnVisible(val);
    },
    // 请求数据
    async getData() {
      this.loading = true
      await getClientList({
        search_map: this.search_map,
        page: this.pagerOptions.currPage,
        pageSize: this.pagerOptions.pageSize
      })
        .then((res) => {
          console.log(res)
          if (res.code === 200) {
            if (res.data.list && res.data.list.length > 0) {
              const list = res.data.list.map((item) => {
                let contact_name = ""
                let contact_phone = ""
                let contact_id = 0
                let contact_wechat = ""
                let contact_email = ""
                let position = ""
                if (item.contacts.length !== 0) {
                  for (let i = 0; i < item.contacts.length; i++) {
                    if (item.contacts[i].is_first) {
                      contact_name = item.contacts[i].name
                      contact_phone = item.contacts[i].phone
                      contact_id = item.contacts[i].id
                      contact_wechat = item.contacts[i].wechat
                      contact_email = item.contacts[i].email
                      position = item.contacts[i].position
                    }
                  }
                }
                return {
                  ...item,
                  contact_name: contact_name,
                  contact_phone: contact_phone,
                  client_level: item.client_level.name,
                  client_status: item.client_status.name,
                  contact_id: contact_id,
                  member_name: item.member.username,
                  contact_wechat: contact_wechat,
                  contact_email: contact_email,
                  position: position
                }
              })
              this.tableList.tableInfomation = list || []
              this.pagerOptions.totalCount = res.data.count
            } else {
              this.tableList.tableInfomation = []
            }
          } else {
            this.tableList.tableInfomation = []
          }
          this.loading = false
        })
        .catch((err) => {
          console.log(err)
          this.tableList.tableInfomation = []
          this.loading = false
        })
    },
    tabsClick(tab) {
      console.log(tab.name)
      if (tab.name === "first") {
        this.not_admin = 2
      } else {
        this.not_admin = 1
      }
      this.search_map = {
        not_admin: this.not_admin
      }
      this.pagerOptions.currPage = 1
      this.getData()
    },
    // 搜索
    onFilterSearch(searchText){
      this.search_map = {
        not_admin: this.not_admin,
        name: searchText
      }
      this.pagerOptions.currPage = 1
      this.getData()
    },
    // 新建
    addBtnClick() {
      this.editConfig.visible = true
      this.editConfig.title = "新建"
      this.editConfig.infomation = {
        city_id: 0,
        client_type_id: 1,
        client_origin_id: 1,
        client_level_id: 1,
        registered_capital_id: 1,
        enterprise_nature_id: 1,
        enterprise_scale_id: 1,
        industry_id: 1
      }
    },
    // 编辑
    handleClick(row) {
      console.log(row)
      this.editConfig.visible = true
      this.editConfig.title = "编辑"
      this.editConfig.infomation = {
        ...row
      }
    },
    // 删除
    delClick() {
      if (this.selValueList && this.selValueList.length > 0) {
        this.$confirm("是否确认删除?", "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            getDeleteClient({ ids: this.selValueList }).then((response) => {
              if (response.code === 200) {
                this.$message.success("删除成功")
                this.getData()
              } else {
                this.$message.warning("删除失败")
              }
            })
          })
          .catch(() => {})
      } else {
        this.$message.warning("请至少选择一条记录")
      }
    },
    getSelectArray(val) {
      console.log(val)
      this.selValueList = []
      const list = val.map((item) => {
        return item.id
      })
      this.selValueList = list
    },
    // 客户名称详情
    selClientClick(row) {
      console.log(row)
      this.clientDeail.visible = true
      this.clientDeail.infomation = { ...row, client_name: row.name }
    },
    // 联系人详情
    selContactsClick(row) {
      this.contactsDeail.visible = true
      let contact = {}
      if (row.contacts.length !== 0) {
        for (let i = 0; i < row.contacts.length; i++) {
          if (row.contacts[i].is_first) {
            contact = row.contacts[i]
          }
        }
      }
      this.contactsDeail.infomation = {
        ...contact,
        Client: { name: row.name, client_status_id: row.client_status_id },
        client_name: row.name
      }
    },
    // 跟进
    followupClick(row) {
      console.log(row)
      this.editFollowupConfig.visible = true
      this.editFollowupConfig.title = "新建"
      this.editFollowupConfig.infomation = {
        ...row,
        client_name: row.name,
        number: "",
        next_follow_time: row.next_visit_time
      }
    },
    // 分配
    allocationBtnClick(row) {
      console.log(row)
      this.allocationConfig.visible = true
      this.allocationConfig.infomation = { member_id: row.member_id, id: row.id }
    },
    // 变更公海
    async changeHighSeasClick(row) {
      await getAssign({
        ids: [row.id],
        member_id: 1,
        type: "client"
      }).then((res) => {
        this.editConfig.visible = false
        if (res.code === 200) {
          this.$message.success("变更成功")
          this.getData()
        }
      })
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>
::v-deep {
  .el-tabs--top .el-tabs__item.is-top:nth-child(2) {
    padding-left: 25px;
  }
  .el-tabs__item {
    padding: 0 25px;
    height: 45px;
  }
}

.custom-manage{
  height: 100%;
  overflow: hidden;
  .filter{
    height: 80px;
    display: flex;
    align-items: center;
    padding: 0 20px 0 20px;
    &-card{
      height: 80px;
      display: flex;
      align-items: center;
      box-sizing: border-box;
      padding: 10px 20px;
      flex: 1;
      border-radius: 12px;
      background-color: #fff;
    }
  }
  .body{
    box-sizing: border-box;
    padding: 10px 20px;
    border-radius: 12px;
    height: calc(100% - 139px);
    .body-card {
      background-color: #fff;
      border-radius: 12px;
      height: 100%;
      overflow: hidden;
    }
    .list-view {
      height: calc(100% - 60px);
      overflow: hidden;
    }
    .btn-pager {
      display: flex;
      margin-top: 10px;
      .page {
        margin-left: auto;
      }
    }
  }
}
</style>
